﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;

namespace ZoomRestrictionSample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult PinkSquare()
        {
            return View("Map", this.MakeMap());
        }

        public ActionResult Zoom1To5WithoutOverlay()
        {
            var map = this.MakeMap();

            map.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Green);
            map.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level05;

            map.ZoomLevelSet.ZoomLevel06.Scale = 0;
            map.ZoomLevelSet.ZoomLevel06.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            return View("Map", map);
        }

        public ActionResult Zoom1To5()
        {
            var map = this.MakeMap();

            map.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Green);
            map.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level05;

            map.ZoomLevelSet.ZoomLevel06.Scale = 0;
            map.ZoomLevelSet.ZoomLevel06.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            map.CustomOverlays.Add(new LayerOverlay());

            return View("Map", map);
        }

        public ActionResult Zoom10To20()
        {
            var map = this.MakeMap();

            map.ZoomLevelSet.ZoomLevel01.Scale = 0;
            map.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level09;

            map.ZoomLevelSet.ZoomLevel10.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Green);
            map.ZoomLevelSet.ZoomLevel10.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            map.CustomOverlays.Add(new LayerOverlay());

            return View("Map", map);
        }

        public ActionResult Zoom5To10()
        {
            var map = this.MakeMap();

            map.ZoomLevelSet.ZoomLevel01.Scale = 0;
            map.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level04;

            map.ZoomLevelSet.ZoomLevel05.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Green);
            map.ZoomLevelSet.ZoomLevel05.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level10;

            map.ZoomLevelSet.ZoomLevel11.Scale = 0;
            map.ZoomLevelSet.ZoomLevel11.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            map.CustomOverlays.Add(new LayerOverlay());

            return View("Map", map);
        }

        private Map MakeMap()
        {
            var map = new Map("Map",
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage),
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage));
            map.MapBackground = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF")));
            map.MapUnit = GeographyUnit.Meter;

            var background = new BingMapsOverlay("BingMap", System.Configuration.ConfigurationManager.AppSettings["BingMapsKey"], BingMapsStyle.Aerial);
            background.IsBaseOverlay = true;
            map.CustomOverlays.Add(background);

            return map;
        }
    }
}